# SRS (Simple Random Sampling)
Sim.SRS <- function(Nit, M=100, m, Density, Pattern){

 Dest <- numeric(Nit)    #̖x̐lۑxNg(Nit̓V~[V)
 Dcvest <- numeric(Nit)   #ϓW̐lۑxNg
 Nanimals <- M*Density
 
 if(Pattern=="A") FUN <- function(x,y) 1
 if(Pattern=="B") FUN <- FUN.B 
 if(Pattern=="C") FUN <- FUN.C
 
 for(it in 1:Nit){
 
  SP <- SpatialDist(Nanimals, FUN)
  X <- SP$X; Y <- SP$Y
 
  nobs <- numeric(m)
  Sunits <- sample(1:M, m, replace=FALSE) 
  xs <- Sunits%%10
  ys <- floor((Sunits-1)/10)
  for(i in 1:m){
   nobs[i] <- sum( (xs[i] < X) & (X <= xs[i]+1) & (ys[i] < Y) & (Y <= ys[i]+1) )
  }
  s2 <- var(nobs)
  Dest[it] <- mean(nobs)
  Dcvest[it] <- sqrt(((M-m)/M)*(s2/m))/Dest[it]
 }
 
 obj <- NULL
 obj$Dest <- Dest
 obj$Dest.mean <- mean(Dest)
 obj$Dest.cv <- sd(Dest)/mean(Dest)
 obj$Dcvest <- Dcvest
 obj$Dcvest.mean <- mean(Dcvest)
 return(obj)
}

Density.true<-5
mvec <- c(5,10,20)
Res.A <- lapply(mvec, Sim.SRS, Nit=1000, M=100, Density=Density.true, Pattern="A")
Res.B <- lapply(mvec, Sim.SRS, Nit=1000, M=100, Density=Density.true, Pattern="B")
Res.C <- lapply(mvec, Sim.SRS, Nit=1000, M=100, Density=Density.true, Pattern="C")

par(mfrow=c(3,3), cex=0.7)
Res <- Res.A
#Res <- Res.B
#Res <- Res.C
for(i in 1:length(mvec)){
 hist(Res[[i]]$Dest, xlim=c(0, 2*Density.true), col="gray80", ann=FALSE)
 title(main=paste("(C) #Samling Units=", mvec[i]), xlab="Estimate of Density")
 points(Density.true, 0, pch=4, col="red")
 points(Res[[i]]$Dest.mean, 0, pch=4, col="blue")
}